com/urls.py
from django.urls import path
from . import views

app_name = 'com'
urlpatterns = [
    path('', views.inbox, name='inbox'),
    path('message/<id_topic>', views.message, name='message'),
    path('contacter/', views.contact, name='contact'),
]

offers/urls.py
from django.urls import path
from . import views

app_name = 'offers'
urlpatterns = [
    path('', views.offers_host, name='offers_host'),
    path('postulants/', views.offers_guest, name='offers_guest'),
    path('ajouter/', views.offers_add, name='offers_add'),
    path('details/h/<offer_id>', views.details_host, name='details_host'),
    path('details/g/<offer_id>', views.details_guest, name='details_guest'),
]

offers/models.py
from django.contrib.auth.models import User
from django.db import models

from offers.validators import validate_file_size

class Offer(models.Model):
    available = models.BooleanField(default=1)
    id_user = models.ForeignKey(User, on_delete=models.CASCADE)

class Host(models.Model):
    id_offer = models.ForeignKey(Offer, on_delete=models.CASCADE)
    title = models.CharField(max_length=50)
    description = models.CharField(max_length=400)
    city = models.CharField(max_length=50)
    street_name = models.CharField(max_length=50)
    street_number = models.CharField(max_length=5)
    postal_code = models.CharField(max_length=10)
    area = models.IntegerField(null=True, blank=True)
    room = models.BooleanField(null=True, blank=True)
    duration = models.IntegerField(null=True, blank=True)
    date_added = models.DateField(auto_now=False, auto_now_add=True)
    date_modified = models.DateField(auto_now=True, auto_now_add=False)
    image = models.ImageField(upload_to='', validators=[validate_file_size])

    def __str__(self):
        return self.title

    def roomstr(self):
        if self.room == 0:
            return "Non"
        else:
            return "Oui"


class Guest(models.Model):
    id_offer = models.ForeignKey(Offer, on_delete=models.CASCADE)
    title = models.CharField(max_length=50)
    description = models.CharField(max_length=400)
    city = models.CharField(max_length=50)
    postal_code = models.CharField(max_length=10)
    duration = models.IntegerField(null=True, blank=True)
    date_added = models.DateField(auto_now=False, auto_now_add=True)
    date_modified = models.DateField(auto_now=True, auto_now_add=False)
    image = models.ImageField(upload_to='', validators=[validate_file_size])

    def __str__(self):
        return self.title

offers/forms.py
from django.forms import ModelForm, Textarea, TextInput
from offers.models import Host, Guest


class HostForm(ModelForm):
    def __init__(self, *args, **kwargs):
        super().__init__(*args, **kwargs)
        self.fields['title'].widget.attrs.update({'class': 'form-control'})
        self.fields['city'].widget.attrs.update({'class': 'form-control'})
        self.fields['street_name'].widget.attrs.update(
            {'class': 'form-control'})
        self.fields['street_number'].widget.attrs.update(
            {'class': 'form-control'})
        self.fields['postal_code'].widget.attrs.update(
            {'class': 'form-control'})
        self.fields['area'].widget.attrs.update({'class': 'form-control'})
        self.fields['room'].widget.attrs.update({'class': 'form-control'})
        self.fields['duration'].widget.attrs.update(
            {'class': 'form-control'})

    class Meta:
        model = Host
        fields = ['title',
                  'description',
                  'city',
                  'street_name',
                  'street_number',
                  'postal_code',
                  'area',
                  'room',
                  'duration',
                  'image']

        labels = {'title': 'Titre',
                  'description': 'Description',
                  'city': 'Ville',
                  'street_name': 'Rue',
                  'street_number': 'Numéro de rue',
                  'postal_code': 'Code postal',
                  'area': 'Surface habitable',
                  'room': 'Chambre individuelle',
                  'duration': 'Durée d\'hébergement'}

        widgets = {
            'description': Textarea(
                attrs={
                    'cols': 40,
                    'rows': 10,
                    'class': 'form-control',
                    'placeholder': 'Description'
                }
            ),
            'duration': TextInput(
                attrs={
                    'placeholder': 'Nombre de mois'
                }
            )
        }


class GuestForm(ModelForm):
    def __init__(self, *args, **kwargs):
        super().__init__(*args, **kwargs)
        self.fields['title'].widget.attrs.update({'class': 'form-control'})
        self.fields['city'].widget.attrs.update({'class': 'form-control'})
        self.fields['postal_code'].widget.attrs.update(
            {'class': 'form-control'})
        self.fields['duration'].widget.attrs.update(
            {'class': 'form-control'})

    class Meta:
        model = Guest
        fields = ['title',
                  'description',
                  'city',
                  'postal_code',
                  'duration',
                  'image'
                  ]

        labels = {'title': 'Titre',
                  'description': 'Description',
                  'city': 'Ville',
                  'postal_code': 'Code postal',
                  'duration': 'Durée d\'hébergement'
                  }

        widgets = {
            'description': Textarea(
                attrs={
                    'cols': 40,
                    'rows': 10,
                    'class': 'form-control',
                    'placeholder': 'Description'
                }
            )
        }

offers/views.py
from django.shortcuts import render, redirect, get_object_or_404
from django.contrib.auth.decorators import login_required
from offers.forms import HostForm, GuestForm
from django.db.models import Q

from offers.models import Offer, Host, Guest


def offers_host(request):
    context = {}

    if request.method == 'POST':
        search = request.POST['search']

        # Get all offers matching the search
        offers_list = Host.objects.filter(
            Q(city__icontains=search) | Q(postal_code__icontains=search))
        context['search'] = search
        context['offers_list'] = offers_list
    else:
        offers_list = Host.objects.all()
        context['offers_list'] = offers_list

    return render(request, 'offers/offers_list.html', context)


def offers_guest(request):
    context = {}

    if request.method == 'POST':
        search = request.POST['search']

        # Get all offers matching the search
        offers_list = Guest.objects.filter(
            Q(city__icontains=search) | Q(postal_code__icontains=search))
        context['search'] = search
        context['offers_list'] = offers_list
    else:
        offers_list = Guest.objects.all()
        context['offers_list'] = offers_list

    return render(request, 'offers/offers_list.html', context)


def details_host(request, offer_id):
    request.session['offer_id'] = None
    request.session['offer_user'] = None

    offer_details = get_object_or_404(Host, id=offer_id)
    offer_user = offer_details.id_offer.id_user

    # Keep data in memory for com.views.contact
    request.session['offer_id'] = offer_details.id_offer_id
    request.session['offer_user'] = offer_user.id

    context = {
        'offer_details': offer_details,
        'its_a_host': 'True',
    }

    return render(request, 'offers/details.html', context)


def details_guest(request, offer_id):
    request.session['offer_id'] = None
    request.session['offer_user'] = None

    offer_details = get_object_or_404(Guest, id=offer_id)
    offer_user = offer_details.id_offer.id_user

    # Keep data in memory for com.views.contact
    request.session['offer_id'] = offer_details.id_offer_id
    request.session['offer_user'] = offer_user.id

    context = {
        'offer_details': offer_details,
    }
    return render(request, 'offers/details.html', context)


@login_required(login_url='/auth/signin/')
def offers_add(request):
    if request.method == 'POST':

        # Create the right form instance according
        # to the choice of the user
        if 'submit-host-form' in request.POST:
            form = HostForm(request.POST, request.FILES)
        if 'submit-guest-form' in request.POST:
            form = GuestForm(request.POST, request.FILES)

        # Check whether it's valid:
        if form.is_valid():
            user = request.user
            new_offer = Offer.objects.create(id_user=user)
            form_offer = form.save(commit=False)
            form_offer.id_user_id = user
            form_offer.id_offer = new_offer
            form_offer.save()

            return redirect('/')

        # In case of invalid form, recreate context with
        # forms errors messages
        else:
            if 'submit-host-form' in request.POST:
                guest_form = GuestForm()
                context = {
                    'host_form': form,
                    'guest_form': guest_form,
                }

            if 'submit-guest-form' in request.POST:
                host_form = HostForm()
                context = {
                    'host_form': host_form,
                    'guest_form': form
                }

    # If a GET (or any other method) we'll create a blank form
    else:
        host_form = HostForm()
        guest_form = GuestForm()
        context = {
            'host_form': host_form,
            'guest_form': guest_form,
        }

    return render(request, 'offers/offers_add.html', context)

offers/templates/offers/details.html
{% extends 'sirmo/base.html' %}
{% block content %}

{% if offer_details %}
<section>
  <div class="container">
    <div class="row justify-content-center">
      <div class="col-lg-10 col-md-12">
        <div class="container offer details">
          <div class="row justify-content-center">
            <div class="image-view details">
              <img class="img-fluid details" src="{{ offer_details.image.url }}" alt="{{ offer_details.image.name }}">
            </div>
          </div>
          <div class="content details">
            <div class="row">
              <div class="col">
                <h5>{{offer_details.title}}</h5>
              </div>
            </div>
            <div class="row">
              <div class="col">
                <p class="description">
                  {{offer_details.description}}
                </p>
              </div>
            </div>
            <div class="row">
              <div class="col">
                <h5 class='details'>Informations complémentaires</h5>
              </div>
            </div>
            <div class="row">
              <div class="col">
                <p class="details"><span class="details">Ville : </span>{{offer_details.city}}</p>
              </div>
              <div class="col">
                <p class="details"><span class="details">Code postal : </span>{{offer_details.postal_code}}</p>
              </div>
            </div>
            <div class="row">
              {% if offer_details.duration %}
              <div class="col">
                <p class="details"><span class="details">Durée d'hébergement : </span>{{offer_details.duration}} mois
                </p>
              </div>
              {% endif %}
              {% if its_a_host %}
              <div class="col">
                <p class="details"><span class="details">Chambre individuelle : </span>{{offer_details.roomstr }}</p>
              </div>
              {% endif %}
            </div>
            <div class="row">
              {% if offer_details.area %}
              <div class="col">
                <p class="details"><span class="details">Surface : </span>{{offer_details.duration}} m²</p>
              </div>
              {% endif %}
            </div>
            <div class="row user">
              <div class="col">
              {% with offer_details.id_offer.id_user.first_name as owner_name  %}
                <h5>Contacter <small><a href="{% url 'com:contact' %}">{{ owner_name }}</a></small></h5>
              {% endwith %}
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</section>
{% else %}
<h1>Une erreur s'est glissée quelque part...</h1>
{% endif %}
{% endblock content %}

offers/templates/offers/offers_add.html
{% extends 'sirmo/base.html' %}

{% block content %}
<section class='section-offers'>
  <div class="container">
    <div class="row justify-content-center">
      <div class="col-lg-6">
        <div class="row justify-content-center">
          <ul class="nav nav-pills mb-3" id="pills-tab" role="tablist">
            <li class="nav-item">
              {% if guest_form.errors %}
              <a class="nav-link active" id="pills-guest-tab" data-toggle="pill" href="#pills-guest" role="tab"
                aria-controls="pills-guest" aria-selected="true">Trouvez une chambre</a>
              {% else %}
              <a class="nav-link" id="pills-guest-tab" data-toggle="pill" href="#pills-guest" role="tab"
                aria-controls="pills-guest" aria-selected="true">Trouvez une chambre</a>
              {% endif %}
            </li>
            <li class="nav-item">
              {% if host_form.errors %}
              <a class="nav-link active" id="pills-host-tab" data-toggle="pill" href="#pills-host" role="tab"
                aria-controls="pills-host" aria-selected="true">Devenez hôte</a>
              {% else %}
              <a class="nav-link" id="pills-host-tab" data-toggle="pill" href="#pills-host" role="tab"
                aria-controls="pills-host" aria-selected="false">Devenez hôte</a>
              {% endif %}
            </li>
          </ul>
        </div>
      </div>
    </div>

    <div class="tab-content" id="pills-tabContent">
      {% if guest_form.errors %}
      <div class="tab-pane fade show active" id="pills-guest" role="tabpanel" aria-labelledby="pills-guest-tab">
        {% else %}
        <div class="tab-pane fade" id="pills-guest" role="tabpanel" aria-labelledby="pills-guest-tab">
          {% endif %}

          <div class="container">
            <div class="row justify-content-center">
              <div class="col-lg-6">
                <form id="guest" action="/logements/ajouter/" enctype="multipart/form-data" method="post">
                  {% csrf_token %}
                  {% for field in guest_form %}
                  <div class="form-group">
                    {{ field.errors }}
                    <label>{{ field.label }}</label>
                    {{ field }}
                    {% if field.help_text %}
                    <p class="help-inline"><small>{{ field.help_text }}</small></p>
                    {% endif %}
                  </div>
                  {% endfor %}
                  <input type="hidden" name="submit-guest-form">
                  <input class="btn btn-primary" type="submit" value="Envoyer">
                </form>
              </div>
            </div>
          </div>
        </div>
        {% if host_form.errors %}
        <div class="tab-pane fade show active" id="pills-host" role="tabpanel" aria-labelledby="pills-host-tab">
          {% else %}
          <div class="tab-pane fade" id="pills-host" role="tabpanel" aria-labelledby="pills-host-tab">
            {% endif %}
            <div class="container">
              <div class="row justify-content-center">
                <div class="col-lg-6">
                  <form id="host" action="/logements/ajouter/" enctype="multipart/form-data" method="post">
                    {% csrf_token %}
                    {% for field in host_form %}
                    <div class="form-group">
                      {{ field.errors }}
                      <label>{{ field.label }}</label>
                      {{ field }}
                      {% if field.help_text %}
                      <p class="help-inline"><small>{{ field.help_text }}</small></p>
                      {% endif %}
                    </div>
                    {% endfor %}
                    <input type="hidden" name="submit-host-form">
                    <input class="btn btn-primary" type="submit" value="Envoyer">
                  </form>
                </div>
              </div>
            </div>
          </div>
        </div>
</section>
{% endblock content %}

offers/templates/offers/offers_list.html
{% extends 'sirmo/base.html' %}
{% block content %}
<section>
  <div class="container-fluid">
    <div class="row justify-content-between">
      <div class=col-12>
    <div class="top-search">  
      {% include 'sirmo/search_form.html' %}
    </div>
  </div>
    </div>
    <div class="row justify-content-center">
      {% if not offers_list %}
      Pas de résultats !
      {% endif %}
      {% for offers in offers_list %}
      <div class="col-lg-4 col-md-6">
        <div class="container offer">
          <div class="row">
            <div class="image-view">
              <img class="img-fluid list" src="{{ offers.image.url }}" alt="{{ offers.image.name }}">
            </div>
          </div>
          <div class="content">
            <div class="row">
              <div class="col">
                {% if request.path == '/logements/' %}
                <h3 class="h3-offer"><a href="{% url 'offers:details_host' offers.id %}">{{ offers.title }}</a></h3>
                {% elif request.path == '/logements/postulants/' %}
                <h3 class="h3-offer"><a href="{% url 'offers:details_guest' offers.id %}">{{ offers.title }}</a></h3>
                {% endif  %}
              </div>
            </div>
            <div class="row">
              <div class="col">
                <p class="description">
                  {{ offers.description }}
                </p>
              </div>
            </div>
          </div>
        </div>
      </div>
      {% endfor %}
    </div>
  </div>

</section>
{% endblock content %}